use futures_util::{SinkExt, StreamExt};
use std::net::SocketAddr;
use tokio::net::{TcpListener, TcpStream};
use tokio_tungstenite::accept_async;
use tokio_tungstenite::tungstenite::protocol::Message;
use tungstenite::Result;

async fn accept_connection(peer: SocketAddr, stream: TcpStream) {
    if let Err(err) = handle_connection(peer, stream).await {
        println!("Error processing connection: {}", err);
    }
}

async fn handle_connection(peer: SocketAddr, stream: TcpStream) -> Result<()> {
    let mut ws_stream = accept_async(stream).await.expect("Failed to accept");

    println!("New WebSocket connection: {}", peer);

    while let Some(msg) = ws_stream.next().await {
        let msg = msg.unwrap();
        if let Message::Text(msg) = msg {
            let response = match msg.trim() {
                r#"{"x":0,"y":1}"# => r#"[{"x":1,"y":1}]"#,
                r#"{"x":1,"y":1}"# => r#"[{"x":0,"y":1},{"x":1,"y":2},{"x":2,"y":1}]"#,
                r#"{"x":1,"y":2}"# => r#"[{"x":1,"y":1},{"x":1,"y":3}]"#,
                r#"{"x":1,"y":3}"# => r#"[{"x":1,"y":2},{"x":1,"y":4}]"#,
                r#"{"x":1,"y":4}"# => r#"[{"x":1,"y":3},{"x":1,"y":5}]"#,
                r#"{"x":1,"y":5}"# => r#"[{"x":1,"y":4},{"x":1,"y":6},{"x":2,"y":5}]"#,
                r#"{"x":1,"y":6}"# => r#"[{"x":1,"y":5}]"#,
                r#"{"x":2,"y":5}"# => r#"[{"x":1,"y":5},{"x":3,"y":5}]"#,
                r#"{"x":3,"y":5}"# => r#"[{"x":2,"y":5},{"x":4,"y":5}]"#,
                r#"{"x":4,"y":5}"# => r#"[{"x":3,"y":5},{"x":4,"y":6}]"#,
                r#"{"x":4,"y":6}"# => r#"[{"x":4,"y":5},{"x":5,"y":6}]"#,
                r#"{"x":5,"y":6}"# => r#"[{"x":4,"y":6},{"x":6,"y":6}]"#,
                r#"{"x":6,"y":6}"# => r#"[{"x":5,"y":6},{"x":7,"y":6}]"#,
                r#"{"x":7,"y":6}"# => r#"[{"x":7,"y":5},{"x":6,"y":6},{"x":8,"y":6}]"#,
                r#"{"x":7,"y":5}"# => r#"[{"x":7,"y":4},{"x":7,"y":6}]"#,
                r#"{"x":7,"y":4}"# => r#"[{"x":7,"y":3},{"x":7,"y":5}]"#,
                r#"{"x":7,"y":3}"# => r#"[{"x":7,"y":2},{"x":7,"y":4}]"#,
                r#"{"x":7,"y":2}"# => r#"[{"x":7,"y":1},{"x":7,"y":3}]"#,
                r#"{"x":7,"y":1}"# => r#"[{"x":6,"y":1},{"x":7,"y":2}]"#,
                r#"{"x":6,"y":1}"# => r#"[{"x":5,"y":1},{"x":7,"y":1}]"#,
                r#"{"x":5,"y":1}"# => r#"[{"x":5,"y":2},{"x":6,"y":1}]"#,
                r#"{"x":5,"y":2}"# => r#"[{"x":5,"y":1},{"x":5,"y":3}]"#,
                r#"{"x":5,"y":3}"# => r#"[{"x":5,"y":2},{"x":4,"y":3}]"#,
                r#"{"x":4,"y":3}"# => r#"[{"x":3,"y":3},{"x":5,"y":3}]"#,
                r#"{"x":3,"y":3}"# => r#"[{"x":3,"y":2},{"x":4,"y":3}]"#,
                r#"{"x":3,"y":2}"# => r#"[{"x":3,"y":1},{"x":3,"y":3}]"#,
                r#"{"x":3,"y":1}"# => r#"[{"x":2,"y":1},{"x":3,"y":2}]"#,
                r#"{"x":2,"y":1}"# => r#"[{"x":1,"y":1},{"x":3,"y":1}]"#,
                r#"{"x":8,"y":6}"# => r#"[{"x":7,"y":6},{"x":8,"y":7},{"x":9,"y":6}]"#,
                r#"{"x":8,"y":7}"# => r#"[{"x":8,"y":6},{"x":8,"y":8}]"#,
                r#"{"x":8,"y":8}"# => r#"[{"x":8,"y":7},{"x":7,"y":8},{"x":9,"y":8}]"#,
                r#"{"x":7,"y":8}"# => r#"[{"x":6,"y":8},{"x":8,"y":8}]"#,
                r#"{"x":6,"y":8}"# => r#"[{"x":5,"y":8},{"x":7,"y":8}]"#,
                r#"{"x":5,"y":8}"# => r#"[{"x":4,"y":8},{"x":5,"y":9},{"x":6,"y":8}]"#,
                r#"{"x":4,"y":8}"# => r#"[{"x":3,"y":8},{"x":5,"y":8}]"#,
                r#"{"x":3,"y":8}"# => r#"[{"x":2,"y":8},{"x":4,"y":8}]"#,
                r#"{"x":2,"y":8}"# => r#"[{"x":1,"y":8},{"x":3,"y":8}]"#,
                r#"{"x":1,"y":8}"# => r#"[{"x":2,"y":8}]"#,
                r#"{"x":5,"y":9}"# => r#"[{"x":5,"y":8}]"#,
                r#"{"x":9,"y":8}"# => r#"[{"x":8,"y":8},{"x":9,"y":9}]"#,
                r#"{"x":9,"y":9}"# => r#"[{"x":9,"y":8},{"x":10,"y":9}]"#,
                r#"{"x":10,"y":9}"# => r#"[{"x":9,"y":9},{"x":11,"y":9}]"#,
                r#"{"x":11,"y":9}"# => r#"[{"x":10,"y":9},{"x":12,"y":9}]"#,
                r#"{"x":12,"y":9}"# => r#"[{"x":12,"y":9,"finish":true}]"#,
                r#"{"x":9,"y":6}"# => r#"[{"x":8,"y":6},{"x":10,"y":6}]"#,
                r#"{"x":10,"y":6}"# => r#"[{"x":10,"y":5},{"x":9,"y":6},{"x":11,"y":6}]"#,
                r#"{"x":10,"y":5}"# => r#"[{"x":10,"y":4},{"x":10,"y":6}]"#,
                r#"{"x":10,"y":4}"# => r#"[{"x":10,"y":3},{"x":10,"y":5}]"#,
                r#"{"x":10,"y":3}"# => r#"[{"x":9,"y":3},{"x":10,"y":4},{"x":11,"y":3}]"#,
                {"x":9,"y":3} => [{"xr#":9,"y":2},{"x""#:10,r#"":3}]"#,
                r#"{"x":9,"y":2}"# => r#"[{"x":9,"y":1},{"x":9,"y":3}]"#,
                r#"{"x":9,"y":1}"# => r#"[{"x":9,"y":2},{"x":10,"y":1}]"#,
                r#"{"x":10,"y":1}"# => r#"[{"x":9,"y":1},{"x":11,"y":1}]"#,
                r#"{"x":11,"y":1}"# => r#"[{"x":10,"y":1},{"x":11,"y":2}]"#,
                r#"{"x":11,"y":2}"# => r#"[{"x":11,"y":1},{"x":11,"y":3}]"#,
                r#"{"x":11,"y":3}"# => r#"[{"x":11,"y":2},{"x":10,"y":3}]"#,
                r#"{"x":11,"y":3}"# => r#"[{"x":11,"y":2},{"x":10,"y":3}]"#,
                r#"{"x":11,"y":2}"# => r#"[{"x":11,"y":1},{"x":11,"y":3}]"#,
                r#"{"x":11,"y":1}"# => r#"[{"x":10,"y":1},{"x":11,"y":2}]"#,
                r#"{"x":10,"y":1}"# => r#"[{"x":9,"y":1},{"x":11,"y":1}]"#,
                r#"{"x":9,"y":1}"# => r#"[{"x":9,"y":2},{"x":10,"y":1}]"#,
                r#"{"x":9,"y":2}"# => r#"[{"x":9,"y":1},{"x":9,"y":3}]"#,
                r#"{"x":9,"y":3}"# => r#"[{"x":9,"y":2},{"x":10,"y":3}]"#,
                r#"{"x":11,"y":6}"# => r#"[{"x":10,"y":6},{"x":11,"y":7}]"#,
                r#"{"x":11,"y":7}"# => r#"[{"x":11,"y":6}]"#,
                r#"{"x":2,"y":1}"# => r#"[{"x":1,"y":1},{"x":3,"y":1}]"#,
                r#"{"x":3,"y":1}"# => r#"[{"x":2,"y":1},{"x":3,"y":2}]"#,
                r#"{"x":3,"y":2}"# => r#"[{"x":3,"y":1},{"x":3,"y":3}]"#,
                r#"{"x":3,"y":3}"# => r#"[{"x":3,"y":2},{"x":4,"y":3}]"#,
                r#"{"x":4,"y":3}"# => r#"[{"x":3,"y":3},{"x":5,"y":3}]"#,
                r#"{"x":5,"y":3}"# => r#"[{"x":5,"y":2},{"x":4,"y":3}]"#,
                r#"{"x":5,"y":2}"# => r#"[{"x":5,"y":1},{"x":5,"y":3}]"#,
                r#"{"x":5,"y":1}"# => r#"[{"x":5,"y":2},{"x":6,"y":1}]"#,
                r#"{"x":6,"y":1}"# => r#"[{"x":5,"y":1},{"x":7,"y":1}]"#,
                r#"{"x":7,"y":1}"# => r#"[{"x":6,"y":1},{"x":7,"y":2}]"#,
                r#"{"x":7,"y":2}"# => r#"[{"x":7,"y":1},{"x":7,"y":3}]"#,
                r#"{"x":7,"y":3}"# => r#"[{"x":7,"y":2},{"x":7,"y":4}]"#,
                r#"{"x":7,"y":4}"# => r#"[{"x":7,"y":3},{"x":7,"y":5}]"#,
                r#"{"x":7,"y":5}"# => r#"[{"x":7,"y":4},{"x":7,"y":6}]"#,
                r#"{"x":7,"y":6}"# => r#"[{"x":7,"y":5},{"x":6,"y":6},{"x":8,"y":6}]"#,
                r#"{"x":6,"y":6}"# => r#"[{"x":5,"y":6},{"x":7,"y":6}]"#,
                r#"{"x":5,"y":6}"# => r#"[{"x":4,"y":6},{"x":6,"y":6}]"#,
                r#"{"x":4,"y":6}"# => r#"[{"x":4,"y":5},{"x":5,"y":6}]"#,
                r#"{"x":4,"y":5}"# => r#"[{"x":3,"y":5},{"x":4,"y":6}]"#,
                r#"{"x":3,"y":5}"# => r#"[{"x":2,"y":5},{"x":4,"y":5}]"#,
                r#"{"x":2,"y":5}"# => r#"[{"x":1,"y":5},{"x":3,"y":5}]"#,
                r#"{"x":1,"y":5}"# => r#"[{"x":1,"y":4},{"x":1,"y":6},{"x":2,"y":5}]"#,
                r#"{"x":1,"y":4}"# => r#"[{"x":1,"y":3},{"x":1,"y":5}]"#,
                r#"{"x":1,"y":3}"# => r#"[{"x":1,"y":2},{"x":1,"y":4}]"#,
                r#"{"x":1,"y":2}"# => r#"[{"x":1,"y":1},{"x":1,"y":3}]"#,
                r#"{"x":1,"y":6}"# => r#"[{"x":1,"y":5}]"#,
                r#"{"x":8,"y":6}"# => r#"[{"x":7,"y":6},{"x":8,"y":7},{"x":9,"y":6}]"#,
                r#"{"x":8,"y":7}"# => r#"[{"x":8,"y":6},{"x":8,"y":8}]"#,
                r#"{"x":8,"y":8}"# => r#"[{"x":8,"y":7},{"x":7,"y":8},{"x":9,"y":8}]"#,
                r#"{"x":7,"y":8}"# => r#"[{"x":6,"y":8},{"x":8,"y":8}]"#,
                r#"{"x":6,"y":8}"# => r#"[{"x":5,"y":8},{"x":7,"y":8}]"#,
                r#"{"x":5,"y":8}"# => r#"[{"x":4,"y":8},{"x":5,"y":9},{"x":6,"y":8}]"#,
                r#"{"x":4,"y":8}"# => r#"[{"x":3,"y":8},{"x":5,"y":8}]"#,
                r#"{"x":3,"y":8}"# => r#"[{"x":2,"y":8},{"x":4,"y":8}]"#,
                r#"{"x":2,"y":8}"# => r#"[{"x":1,"y":8},{"x":3,"y":8}]"#,
                r#"{"x":1,"y":8}"# => r#"[{"x":2,"y":8}]"#,
                r#"{"x":5,"y":9}"# => r#"[{"x":5,"y":8}]"#,
                r#"{"x":9,"y":8}"# => r#"[{"x":8,"y":8},{"x":9,"y":9}]"#,
                r#"{"x":9,"y":9}"# => r#"[{"x":9,"y":8},{"x":10,"y":9}]"#,
                r#"{"x":10,"y":9}"# => r#"[{"x":9,"y":9},{"x":11,"y":9}]"#,
                r#"{"x":11,"y":9}"# => r#"[{"x":10,"y":9},{"x":12,"y":9}]"#,
                r#"{"x":12,"y":9}"# => r#"[{"x":12,"y":9,"finish":true}]"#,
                r#"{"x":9,"y":6}"# => r#"[{"x":8,"y":6},{"x":10,"y":6}]"#,
                r#"{"x":10,"y":6}"# => r#"[{"x":10,"y":5},{"x":9,"y":6},{"x":11,"y":6}]"#,
                r#"{"x":10,"y":5}"# => r#"[{"x":10,"y":4},{"x":10,"y":6}]"#,
                r#"{"x":10,"y":4}"# => r#"[{"x":10,"y":3},{"x":10,"y":5}]"#,
                r#"{"x":10,"y":3}"# => r#"[{"x":9,"y":3},{"x":10,"y":4},{"x":11,"y":3}]"#,
                r#"{"x":9,"y":3}"# => r#"[{"x":9,"y":2},{"x":10,"y":3}]"#,
                r#"{"x":9,"y":2}"# => r#"[{"x":9,"y":1},{"x":9,"y":3}]"#,
                r#"{"x":9,"y":1}"# => r#"[{"x":9,"y":2},{"x":10,"y":1}]"#,
                r#"{"x":10,"y":1}"# => r#"[{"x":9,"y":1},{"x":11,"y":1}]"#,
                r#"{"x":11,"y":1}"# => r#"[{"x":10,"y":1},{"x":11,"y":2}]"#,
                r#"{"x":11,"y":2}"# => r#"[{"x":11,"y":1},{"x":11,"y":3}]"#,
                r#"{"x":11,"y":3}"# => r#"[{"x":11,"y":2},{"x":10,"y":3}]"#,
                r#"{"x":11,"y":3}"# => r#"[{"x":11,"y":2},{"x":10,"y":3}]"#,
                r#"{"x":11,"y":2}"# => r#"[{"x":11,"y":1},{"x":11,"y":3}]"#,
                r#"{"x":11,"y":1}"# => r#"[{"x":10,"y":1},{"x":11,"y":2}]"#,
                r#"{"x":10,"y":1}"# => r#"[{"x":9,"y":1},{"x":11,"y":1}]"#,
                r#"{"x":9,"y":1}"# => r#"[{"x":9,"y":2},{"x":10,"y":1}]"#,
                r#"{"x":9,"y":2}"# => r#"[{"x":9,"y":1},{"x":9,"y":3}]"#,
                r#"{"x":9,"y":3}"# => r#"[{"x":9,"y":2},{"x":10,"y":3}]"#,
                r#"{"x":11,"y":6}"# => r#"[{"x":10,"y":6},{"x":11,"y":7}]"#,
                r#"{"x":11,"y":7}"# => r#"[{"x":11,"y":6}]"#,
                _ => "[]",
            };
            ws_stream.send(Message::Text(response.to_string())).await.unwrap();
        }
    }

    Ok(())
}

#[tokio::main]
async fn main() {
    let addr = "127.0.0.1:9002";
    let listener = TcpListener::bind(&addr).await.expect("Can't listen");
    println!("Listening on: {}", addr);

    while let Ok((stream, _)) = listener.accept().await {
        let peer = stream.peer_addr().expect("connected streams should have a peer address");
        println!("Peer address: {}", peer);

        tokio::spawn(accept_connection(peer, stream));
    }
}
